﻿let run_run_option = 0;

let run2_run_option = 0;
let run2_latency1 = null;
let run2_latency2 = null;

let run3_run_option = 0;
let run3_wpm = null;

let run4_run_option = 0;
let run4_wpm1 = null;
let run4_wpm2 = null;

let run5_run_option = 0;

let run6_run_option = 0;
let run6_target = 1;

let run7_run_option = 0;
let run7_target = 1;

async function getOption(){
  let items = await chrome.storage.local.get([
      'run_run_option',
      'run2_run_option',
      'run2_latency1',
      'run2_latency2',
      'run3_run_option',
      'run3_wpm',
      'run4_run_option',
      'run4_wpm1',
      'run4_wpm2',
      'run5_run_option',
      'run6_run_option',
      'run6_target',
      'run7_run_option',
      'run7_target',
    ]);

  if(items.run_run_option){
    run_run_option = items.run_run_option;
  }
  if(items.run2_run_option){
    run2_run_option = items.run2_run_option;
  }
  if(items.run2_latency1){
    run2_latency1 = items.run2_latency1;
  }
  if(items.run2_latency2){
    run2_latency2 = items.run2_latency2;
  }
  if(items.run3_run_option){
    run3_run_option = items.run3_run_option;
  }
  if(items.run3_wpm){
    run3_wpm = items.run3_wpm;
  }
  if(items.run4_run_option){
    run4_run_option = items.run4_run_option;
  }
  if(items.run4_wpm1){
    run4_wpm1 = items.run4_wpm1;
  }
  if(items.run4_wpm2){
    run4_wpm2 = items.run4_wpm2;
  }
  if(items.run5_run_option){
    run5_run_option = items.run5_run_option;
  }
  if(items.run6_run_option){
    run6_run_option = items.run6_run_option;
  }
  if(items.run6_target){
    run6_target = items.run6_target;
  }
  if(items.run7_run_option){
    run7_run_option = items.run7_run_option;
  }
  if(items.run7_target){
    run7_target = items.run7_target;
  }

  changeOptionDisplay();
}

function changeOptionDisplay(){
  if(run_run_option === '1'){
    document.getElementById('run_yes').checked=true;
    document.getElementById('run_no').checked=false;
  }
  else{
    document.getElementById('run_yes').checked=false;
    document.getElementById('run_no').checked=true;
  }
  if(run2_run_option === '1'){
    document.getElementById('run2_yes').checked=true;
    document.getElementById('run2_no').checked=false;
  }
  else{
    document.getElementById('run2_yes').checked=false;
    document.getElementById('run2_no').checked=true;
  }
  if(run3_run_option === '1'){
    document.getElementById('run3_yes').checked=true;
    document.getElementById('run3_no').checked=false;
  }
  else{
    document.getElementById('run3_yes').checked=false;
    document.getElementById('run3_no').checked=true;
  }
  if(run4_run_option === '1'){
    document.getElementById('run4_yes').checked=true;
    document.getElementById('run4_no').checked=false;
  }
  else{
    document.getElementById('run4_yes').checked=false;
    document.getElementById('run4_no').checked=true;
  }
  if(run5_run_option === '1'){
    document.getElementById('run5_yes').checked=true;
    document.getElementById('run5_no').checked=false;
  }
  else{
    document.getElementById('run5_yes').checked=false;
    document.getElementById('run5_no').checked=true;
  }
  if(run6_run_option === '1'){
    document.getElementById('run6_yes').checked=true;
    document.getElementById('run6_no').checked=false;
  }
  else{
    document.getElementById('run6_yes').checked=false;
    document.getElementById('run6_no').checked=true;
  }
  if(run7_run_option === '1'){
    document.getElementById('run7_yes').checked=true;
    document.getElementById('run7_no').checked=false;
  }
  else{
    document.getElementById('run7_yes').checked=false;
    document.getElementById('run7_no').checked=true;
  }
  if(run2_latency1 !== ''){
    document.getElementById('run2_latency1').value = run2_latency1;
  }
  if(run2_latency2 !== ''){
    document.getElementById('run2_latency2').value = run2_latency2;
  }
  if(run3_wpm !== ''){
    document.getElementById('run3_wpm').value = run3_wpm;
  }
  if(run4_wpm1 !== ''){
    document.getElementById('run4_wpm1').value = run4_wpm1;
  }
  if(run4_wpm2 !== ''){
    document.getElementById('run4_wpm2').value = run4_wpm2;
  }
  if(run6_target === '1'){
    document.getElementById('run6_rkpm').checked=true;
    document.getElementById('run6_wpm').checked=false;
  }
  else{
    document.getElementById('run6_rkpm').checked=false;
    document.getElementById('run6_wpm').checked=true;
  }
  if(run7_target === '1'){
    document.getElementById('run7_median').checked=true;
    document.getElementById('run7_max').checked=false;
  }
  else{
    document.getElementById('run7_median').checked=false;
    document.getElementById('run7_max').checked=true;
  }
}

function setOption(){
  let elements = document.getElementsByName('run');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run_run_option = elements[i].value;
    }
  }
  elements = document.getElementsByName('run2');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run2_run_option = elements[i].value;
    }
  }
  elements = document.getElementsByName('run3');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run3_run_option = elements[i].value;
    }
  }
  elements = document.getElementsByName('run4');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run4_run_option = elements[i].value;
    }
  }
  elements = document.getElementsByName('run5');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run5_run_option = elements[i].value;
    }
  }
  elements = document.getElementsByName('run6');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run6_run_option = elements[i].value;
    }
  }
  elements = document.getElementsByName('run7');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run7_run_option = elements[i].value;
    }
  }
  let run2_latency1_element = document.getElementById('run2_latency1');
  if(run2_latency1_element){
    run2_latency1 = run2_latency1_element.value;
  }
  let run2_latency2_element = document.getElementById('run2_latency2');
  if(run2_latency2_element){
    run2_latency2 = run2_latency2_element.value;
  }
  let run3_wpm_element = document.getElementById('run3_wpm');
  if(run3_wpm_element){
    run3_wpm = run3_wpm_element.value;
  }
  let run4_wpm1_element = document.getElementById('run4_wpm1');
  if(run4_wpm1_element){
    run4_wpm1 = run4_wpm1_element.value;
  }
  let run4_wpm2_element = document.getElementById('run4_wpm2');
  if(run4_wpm2_element){
    run4_wpm2 = run4_wpm2_element.value;
  }
  elements = document.getElementsByName('run6_target');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run6_target = elements[i].value;
    }
  }
  elements = document.getElementsByName('run7_target');
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      run7_target = elements[i].value;
    }
  }

  chrome.storage.local.set({
    'run_run_option': run_run_option,
    'run2_run_option': run2_run_option,
    'run2_latency1': run2_latency1,
    'run2_latency2': run2_latency2,
    'run3_run_option': run3_run_option,
    'run3_wpm': run3_wpm,
    'run4_run_option': run4_run_option,
    'run4_wpm1': run4_wpm1,
    'run4_wpm2': run4_wpm2,
    'run5_run_option': run5_run_option,
    'run6_run_option': run6_run_option,
    'run6_target': run6_target,
    'run7_run_option': run7_run_option,
    'run7_target': run7_target 
  });
}

async function resetData(){
  let items = await chrome.storage.local.get([
    'run_run_option',
    'run2_run_option',
    'run2_latency1',
    'run2_latency2',
    'run3_run_option',
    'run3_wpm',
    'run4_run_option',
    'run4_wpm1',
    'run4_wpm2',
    'run5_run_option',
    'run6_run_option',
    'run6_target',
    'run7_run_option',
    'run7_target',
  ]);

  chrome.storage.local.clear();

  chrome.storage.local.set({
    'run_run_option': items.run_run_option,
    'run2_run_option': items.run2_run_option,
    'run2_latency1': items.run2_latency1,
    'run2_latency2': items.run2_latency2,
    'run3_run_option': items.run3_run_option,
    'run3_wpm': items.run3_wpm,
    'run4_run_option': items.run4_run_option,
    'run4_wpm1': items.run4_wpm1,
    'run4_wpm2': items.run4_wpm2,
    'run5_run_option': items.run5_run_option,
    'run6_run_option': items.run6_run_option,
    'run6_target': items.run6_target,
    'run7_run_option': items.run7_run_option,
    'run7_target': items.run7_target 
  });
}

window.addEventListener('load', () => {
  getOption();
});

document.getElementById("save").addEventListener('click', () => {
  setOption();
});

document.getElementById("reset").addEventListener('click', () => {
  const reset_confirm = confirm('すべての打ち切りデータがリセットされます。よろしいですか？');
  if(reset_confirm == true){
    console.log('--- reset is activated ---');
    resetData();
  }
});

document.getElementById("run").addEventListener('click', () => {
  let elements = document.getElementsByName('run');
  let check_value = '';
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run",
          "run_option": check_value,
        });
  });
});

document.getElementById("run2").addEventListener('click', () => {
  let elements = document.getElementsByName('run2');
  let check_value = '';
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  let latency1 = document.getElementById('run2_latency1').value;
  let latency2 = document.getElementById('run2_latency2').value;
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run2",
          "run_option": check_value,
          "latency1": latency1,
          "latency2": latency2,
        });
  });
});

document.getElementById("run3").addEventListener('click', () => {
  let elements = document.getElementsByName('run3');
  let check_value = '';
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  let wpm = document.getElementById('run3_wpm').value;
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run3",
          "run_option": check_value,
          "wpm": wpm,
        });
  });
});

document.getElementById("run4").addEventListener('click', () => {
  let elements = document.getElementsByName('run4');
  let check_value = '';
  let wpm1 = document.getElementById('run4_wpm1').value;
  let wpm2 = document.getElementById('run4_wpm2').value;
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run4",
          "run_option": check_value,
          "wpm1": wpm1,
          "wpm2": wpm2,
        });
  });
});

document.getElementById("run5").addEventListener('click', () => {
  let elements = document.getElementsByName('run5');
  let check_value = '';
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run5",
          "run_option": check_value,
        });
  });
});

document.getElementById("run6").addEventListener('click', () => {
  let elements = document.getElementsByName('run6');
  let check_value = '';
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  let elements2 = document.getElementsByName('run6_target');
  let check_value2 = '';
  for (let i = 0; i < elements2.length; i++){
    if (elements2[i].checked){
      check_value2 = elements2[i].value;
    }
  }
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run6",
          "run_option": check_value,
          "target": check_value2,
        });
  });
});

document.getElementById("run7").addEventListener('click', () => {
  let elements = document.getElementsByName('run7');
  let check_value = '';
  for (let i = 0; i < elements.length; i++){
    if (elements[i].checked){
      check_value = elements[i].value;
    }
  }
  let elements2 = document.getElementsByName('run7_target');
  let check_value2 = '';
  for (let i = 0; i < elements2.length; i++){
    if (elements2[i].checked){
      check_value2 = elements2[i].value;
    }
  }
  chrome.tabs.query({ active: true, currentWindow: true },
    tabs => {
      chrome.tabs.sendMessage(tabs[0].id, 
        {
          "msg": "run7",
          "run_option": check_value,
          "target": check_value2,
        });
  });
});